#include <string.h>
#include <time.h>
#include "../includes/prompt_and_read.h"
#include "../includes/staff.h"

double mean_work_time (Employee* staff, int n, int current_year) {
	double mean = 0.0;
	for (int i = 0; i < n; i++) {
		int employment = current_year - staff[i].employment_date.year;
		mean += employment;
		printf("%15s%10s%5d\n", staff[i].lastname, staff[i].firstname, employment);
	}
	return mean / n;
}

int read_data(Employee *staff) {
	int n = 0;
	while (1) {
		char *buffer = prompt_and_read_string(NULL);
		if (buffer == NULL) return n;
		strcpy(staff[n].lastname, buffer);
		strcpy(staff[n].firstname, prompt_and_read_string(NULL));
		strcpy(staff[n].address, prompt_and_read_string(NULL));
		staff[n].wages = prompt_and_read_double(NULL);
		staff[n].birthdate.year = prompt_and_read_int(NULL);
		staff[n].birthdate.month = prompt_and_read_int(NULL);
		staff[n].birthdate.day = prompt_and_read_int(NULL);
		staff[n].employment_date.year = prompt_and_read_int(NULL);
		staff[n].employment_date.month = prompt_and_read_int(NULL);
		staff[n].employment_date.day = prompt_and_read_int(NULL);
		++n;
	}
}

int main(void) {
	enum { MAX = 100 };
	Employee staff[MAX];
	time_t sec = time(0);

	struct tm *dt = localtime(&sec);
	printf("Today is %02d/%02d/%d\n", dt->tm_mday, dt->tm_mon+1, dt->tm_year+1900);
	printf("\n");

	int n = read_data(staff);
	double mean = mean_work_time(staff, n, dt->tm_year+1900);
	printf("\n");
	printf("Mean work time = %.1f\n", mean);

	return EXIT_SUCCESS;
}

