#include <string.h>
#include "../includes/prompt_and_read.h"

enum { MAX = 100 };

typedef union {
	int n;
	double d;
	char s[10];
} AnyValue;

typedef struct {
	char name[10];
	int type;
	AnyValue val;
} Variable;

int read_vars (Variable* vars);
void print_vars (Variable* vars, int n);

int main(void) {

	Variable vars[MAX];
	int n = read_vars(vars);
	print_vars(vars, n);

	return EXIT_SUCCESS;
}

int read_vars (Variable* vars) {
	int n = prompt_and_read_int(NULL);
	for (int i = 0; i < n; i++) {
		strcpy(vars[i].name, prompt_and_read_string(NULL));
		vars[i].type = prompt_and_read_int(NULL);
		switch(vars[i].type) {
		case 1:
			vars[i].val.n = prompt_and_read_int(NULL);
			break;
		case 2:
			vars[i].val.d = prompt_and_read_double(NULL);
			break;
		case 3:
			strcpy(vars[i].val.s, prompt_and_read_string(NULL));
			break;
		default:
			printf("Wrong type %d\n", vars[i].type);
			break;
		}
	}
	return n;
}
		

void print_vars (Variable* vars, int n) {
	static const char *types[] = {"int", "double", "string"};
	for (int i = 0; i < n; i++) {
		printf("%10s", vars[i].name);
		printf("%8s", types[vars[i].type-1]);
		switch(vars[i].type) {
		case 1:
			printf("%10d", vars[i].val.n);
			break;
		case 2:
			printf("%10.2f", vars[i].val.d);
			break;
		case 3:
			printf("%10s", vars[i].val.s);
			break;
		default: 
			printf("Wrong type %d", vars[i].type);
			break;
		}
		printf("\n");
	}
}

